import java.io.*;
import java.net.*;
import com.sun.net.httpserver.*;

import java.util.logging.*;


class ClaimRouteHandler implements HttpHandler {

	private static Logger logger;

    static {
        logger = Logger.getLogger("tickettoride");
    }
	
	@Override
	public void handle(HttpExchange exchange) throws IOException {
		
		boolean success = false;
	
        logger.entering("ClaimRouteHandler", "handle");
		
		try {
			if (exchange.getRequestMethod().toLowerCase().equals("post")) {
				
				Headers reqHeaders = exchange.getRequestHeaders();
				if (reqHeaders.containsKey("Authorization")) {
				
					String authToken = reqHeaders.getFirst("Authorization");
					if (authToken.equals("afj232hj2332")) {
					
						InputStream reqBody = exchange.getRequestBody();			
						String reqData = readString(reqBody);

						logger.fine(reqData);
						
						// TODO: Claim a route based on the request data
						
						exchange.sendResponseHeaders(HttpURLConnection.HTTP_OK, 0);
					
						success = true;
					}
				}
			}
			
			if (!success) {
				exchange.sendResponseHeaders(HttpURLConnection.HTTP_BAD_REQUEST, 0);
			}
		}
		catch (IOException e) {
            logger.log(Level.SEVERE, e.getMessage(), e);

			exchange.sendResponseHeaders(HttpURLConnection.HTTP_SERVER_ERROR, 0);
		}
		
        logger.exiting("ClaimRouteHandler", "handle");
	}
	
	private String readString(InputStream is) throws IOException {
		StringBuilder sb = new StringBuilder();
		InputStreamReader sr = new InputStreamReader(is);
		char[] buf = new char[1024];
		int len;
		while ((len = sr.read(buf)) > 0) {
			sb.append(buf, 0, len);
		}
		return sb.toString();
	}
}
